Summary:      Advanced drum machine for GNU/Linux
Name:         hydrogen
Version:      0.9.4.1
Release:      1%{?dist}
URL:          http://www.hydrogen-music.org/
Source0:      http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
# For convenience, to take the svn snapshot:
Source9:      hydrogen-snapshot.sh
# portmidi-200 needs a new patch. Causes RHBZ#555488
Patch0:       hydrogen-portmidi-200.patch
# Fix DSO linking. RHBZ#564719. Sent to upstream ML:
Patch1:       hydrogen-linking.patch
# Fix ladspa plugin path in 64bit systems
Patch2:       hydrogen-lib64.patch
# Fix wasp ladspa plugin linking
Patch3:       wasp-linking.patch
# Fix qt-4.7 build issue
Patch4:       hydrogen-qt47.patch
License:      GPLv2+
Group:        Applications/Multimedia
BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: alsa-lib-devel
BuildRequires: desktop-file-utils
BuildRequires: flac-devel 
BuildRequires: jack-audio-connection-kit-devel
BuildRequires: ladspa-devel
BuildRequires: lash-devel 
BuildRequires: liblrdf-devel
BuildRequires: libsndfile-devel
BuildRequires: libtar-devel
BuildRequires: portaudio-devel
BuildRequires: portmidi-devel
BuildRequires: qt4-devel
BuildRequires: scons

%{?_qt4_version:Requires: qt4%{?_isa} >= %{_qt4_version}}

%description
Hydrogen is an advanced drum machine for GNU/Linux. It's main goal is to bring 
professional yet simple and intuitive pattern-based drum programming.

# According tothe old  wasp home page
# http://linux01.gwdg.de/~nlissne/wasp/index.html
# wasp code is now maintained in hydrogen tree.
%package -n ladspa-wasp-plugins
Summary:       Wave Sculpting Plugins
Group:         Applications/Multimedia
License:       GPLv2+
Requires:      ladspa

%description -n ladspa-wasp-plugins
The Wave Sculpting Plugins (WASP) is a set of LADSPA plugins which includes both
processors and generators. While being pretty simple and not CPU-hungry, they
incorporate such interesting algorithms as a multi-mode wave shaper, noisifier,
clipping booster and variable noise source.

WASP is now part of the hydrogen drum machine.


%prep
%setup -q -n %{version}
patch -p0 < patches/portaudio.patch
%if 0%{fedora} < 13
patch -p0 < patches/portmidi.patch
%else
%patch0 -p1 -b .200
%endif
%patch1 -p1 -b .linking
%patch2 -p1 -b .lib64
%patch3 -p1 -b .wasp.linking
%patch4 -p1 -b .qt47

%build
export QTDIR=%{_qt4_prefix}
scons %{?_smp_mflags} prefix=%{_prefix} portaudio=1 portmidi=1 lash=1 oss=0 optflags="$RPM_OPT_FLAGS"

# Build the wasp plugins
pushd plugins
    %{_qt4_qmake}
    make %{?_smp_mflags}
popd

%install
rm -rf $RPM_BUILD_ROOT
export QTDIR=%{_qt4_prefix}
scons install DESTDIR=$RPM_BUILD_ROOT


# install hydrogen.desktop properly.
desktop-file-install --vendor fedora              \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications   \
  --add-category X-Drumming                       \
  --add-category Midi                             \
  --add-category X-Jack                           \
  --add-category AudioVideoEditing                \
  --remove-mime-type text/xml                     \
  --delete-original                               \
  $RPM_BUILD_ROOT%{_datadir}/applications/hydrogen.desktop

# Move the icon to the proper place
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/scalable/apps/
mv $RPM_BUILD_ROOT%{_datadir}/pixmaps/*.svg \
   $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/scalable/apps/

# No need to package these (they will not be installed automatically in rc3?):
rm -f $RPM_BUILD_ROOT%{_datadir}/hydrogen/data/doc/{Makefile,README}* \
      $RPM_BUILD_ROOT%{_datadir}/hydrogen/data/doc/*.{docbook,po,pot}

#Install the wasp plugins
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ladspa
cp -a plugins/libwasp*.so $RPM_BUILD_ROOT%{_libdir}/ladspa/

%clean
rm -rf $RPM_BUILD_ROOT


%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
        touch --no-create %{_datadir}/icons/hicolor &>/dev/null
        gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING* README.txt
%{_bindir}/hydrogen
%{_datadir}/hydrogen/
%{_datadir}/applications/fedora-hydrogen.desktop
%{_datadir}/icons/hicolor/scalable/apps/*.svg

%files -n ladspa-wasp-plugins
%defattr(-,root,root,-)
%doc plugins/wasp/AUTHORS plugins/wasp/ChangeLog plugins/wasp/LICENSE
%{_libdir}/ladspa/libwasp*.so


%changelog
* Sat Apr 10 2010 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4.1-1
- Update to 0.9.4.1
- Build the wasp plugins
- Fixes ladspa plugin path on 64bit systems
- Fixes crash RHBZ#570348

* Sat Feb 13 2010 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-3
- Fix DSO linking RHBZ#564719

* Sat Jan 30 2010 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-2
- Add patch against portmidi-200 on F13+. Fixes RHBZ#555488

* Tue Sep 15 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-1
- Update to 0.9.4

* Sat Aug 22 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-0.7.rc2
- Update to 0.9.4-rc2

* Wed Aug 05 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-0.6.rc1.1
- Update .desktop file

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.4-0.5.rc1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jul 14 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-0.4.rc1.1
- Rebuild against new lash build on F-12 due to the e2fsprogs split

* Tue Apr 14 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-0.3.rc1.1
- Update to 0.9.4-rc1-1

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.4-0.2.790svn
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Feb 13 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.9.4-0.1.790svn
- Update to 0.9.4-beta3 (uses scons and qt4)

* Fri Apr 04 2008 Lubomir Kundrak <lkundrak@redhat.com> - 0.9.3-13
- QT3 changes by rdieter
- Fix build

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.3-12
- Autorebuild for GCC 4.3

* Thu Jan 03 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.9.3-11
- Previous change was not a good idea
- Adding missing includes to fix build with gcc-4.3

* Sun Oct 14 2007 Lubomir Kundrak <lkundrak@redhat.com> 0.9.3-10
- Remove unneeded dependencies on desktop-file-utils

* Mon Oct 09 2007 Lubomir Kundrak <lkundrak@redhat.com> 0.9.3-9
- Incorporate fixes from #190040, thanks to Hans de Goede
- Removed useless LIBDIR introduced in previous revision
- Fixed desktop file installation
- Call gtk-update-icon-cache only if it is present

* Sun Oct 07 2007 Lubomir Kundrak <lkundrak@redhat.com> 0.9.3-8
- Remove -j from make to fix concurrency problems
- Handle libdir on 64bit platforms correctly
- Rename patches

* Sat Oct 06 2007 Lubomir Kundrak <lkundrak@redhat.com> 0.9.3-7.1
- Fix desktop file
- Fix compatibility with new FLAC
- Fix linking for Build ID use

* Mon Mar 26 2007 Anthony Green <green@redhat.com> 0.9.3-7
- Improve Source0 link.
- Add %%post(un) scriptlets for MimeType update.
- Add update-desktop-database scriptlets.

* Sat Jul 22 2006 Anthony Green <green@redhat.com> 0.9.3-6
- Add hydrogen-null-sample.patch to fix crash.

* Sun Jul 02 2006 Anthony Green <green@redhat.com> 0.9.3-5
- Clean up BuildRequires.
- Configure with --disable-oss-support
- Don't run ldconfig (not needed)
- Remove post/postun scriptlets.

* Sat May 13 2006 Anthony Green <green@redhat.com> 0.9.3-4
- BuildRequire libxml2-devel.
- Remove explicit Requires for some runtime libraries.
- Set QTDIR via /etc/profile.d/qt.sh.
- Update desktop icons and icon cache in post and postun.
- Don't use __rm or __make macros.

* Sat May 13 2006 Anthony Green <green@redhat.com> 0.9.3-3
- Conditionally apply ardour-lib64-ladspa.patch.

* Sat May 13 2006 Anthony Green <green@redhat.com> 0.9.3-2
- Build fixes for x86_64.

* Wed Apr 26 2006 Anthony Green <green@redhat.com> 0.9.3-1
- Created.
